package com.Spring;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class CalculateSpringAOP {

    final static Logger logger = Logger.getLogger(CalculateSpringAOP.class);

    private Operation ops;

    private ResultWriter wtr;

    public void setOps(Operation ops) {
        this.ops = ops;
    }

    public void setWriter(ResultWriter writer) {
        wtr = writer;
    }

    public static void main(String[] args) {
        logger.info("Initializing Spring context.");

        ApplicationContext context = new ClassPathXmlApplicationContext(
                "/com/Spring/beans.xml");

        BeanFactory factory = (BeanFactory) context;
        CalculateSpringAOP calc = (CalculateSpringAOP) factory
                .getBean("opsbean");

        calc.execute(args);
    }

    public void execute(String[] args) {
        long op1 = Long.parseLong(args[0]);
        long op2 = Long.parseLong(args[1]);
        wtr.showResult("The result of " + op1 + ops.getOpsName() + op2 + " is "
                + ops.operate(op1, op2) + "!");

    }

}
